SystemOrganization addCategory: #TareaB!

Object subclass: #DanielAlgorithms
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TareaB'!

!DanielAlgorithms methodsFor: 'as yet unclassified' stamp: 'Deniels 12/16/2011 01:44'!
findFreeNodes: view
	"method to find all free node"
	|freeNodes free |
	freeNodes := OrderedCollection new.
	view root nodesDo:[:node | 
	((node incomingEdges) size = 0) ifTrue: [((node outgoingEdges) size = 0) ifTrue: [freeNodes add: node.]]].
	free := freeNodes collect: #model.
	Transcript show: free.
	view treeLayout.
	view open.
	^free! !

!DanielAlgorithms methodsFor: 'as yet unclassified' stamp: 'Deniels 12/16/2011 01:31'!
theMostFanInNode: view
	"method to find the node who has most incomingEdges"
	|maxFanIn theNode theMostFanInNode|
	maxFanIn := 0.
	view root nodesDo:[:node | 
	((node incomingEdges) size > maxFanIn) ifTrue: [
		maxFanIn := (node incomingEdges) size.
		theNode := node]].
	theMostFanInNode := OrderedCollection new.
	theMostFanInNode add: theNode.
	theNode := theMostFanInNode collect: #model.
	view treeLayout.
	view open.
	^theNode! !

!DanielAlgorithms methodsFor: 'as yet unclassified' stamp: 'Deniels 12/16/2011 01:31'!
theMostFanOutNode: view
	"method to find the node who has most incomingEdges"
	|maxFanOut theNode theMostFanOutNode|
	maxFanOut := 0.
	view root nodesDo:[:node | 
	((node outgoingEdges) size > maxFanOut) ifTrue: [
		maxFanOut := (node outgoingEdges) size.
		theNode := node]].
	theMostFanOutNode := OrderedCollection new.
	theMostFanOutNode add: theNode.
	theNode := theMostFanOutNode collect: #model.
	view treeLayout.
	view open.
	^theNode! !

Object subclass: #ReadMe
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TareaB'!

!ReadMe methodsFor: 'as yet unclassified' stamp: 'Deniels 12/15/2011 00:02'!
readMe
	"Project Name: Graph Algorithm in Mondrian
		This project is to implement a serie of algorithms to identify certain characteristics in graphos "! !

TestCase subclass: #AlgorithmsTest
	instanceVariableNames: 'view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TareaB'!

!AlgorithmsTest methodsFor: 'as yet unclassified' stamp: 'Deniels 12/16/2011 01:27'!
setUp 
	view := MOViewRenderer new.
	view nodes: (1 to: 6).
	view edgesFromAssociations: {
		"the node 3 is free"
		"the node 1 has more than others outgoingEdges"
		"the node 5 has more than others incomingEdges"
		1 -> 2.
		1 -> 4.
		2 -> 5.
		1 -> 5
	}.! !

!AlgorithmsTest methodsFor: 'as yet unclassified' stamp: 'Deniels 12/15/2011 23:54'!
testFreeNodes 
	|res freeNode respuesta|
	freeNode := DanielAlgorithms new.
	res := freeNode findFreeNodes: view.
	respuesta := OrderedCollection new.
	respuesta add: 3.
	respuesta add: 6.
"	Transcript show: res; cr.
	Transcript show: respuesta; cr."
	self assert: (res) = respuesta! !

!AlgorithmsTest methodsFor: 'as yet unclassified' stamp: 'Deniels 12/16/2011 00:00'!
testMostFanInNode
	|res fanIn respuesta|
	fanIn := DanielAlgorithms new.
	res := fanIn theMostFanInNode: view.
	respuesta := OrderedCollection new.
	respuesta add: 5.
	self assert: (res) = respuesta! !

!AlgorithmsTest methodsFor: 'as yet unclassified' stamp: 'Deniels 12/16/2011 01:30'!
testMostFanOutNode
	|res fanOut respuesta|
	fanOut := DanielAlgorithms new.
	res := fanOut theMostFanOutNode: view.
	"Transcript show: res; cr".
	respuesta := OrderedCollection new.
	respuesta add: 1.
	self assert: (res) = respuesta
	! !
